package org.lightj.concurrent;

import java.util.concurrent.Callable;

/**
 * convenience queue task class to be used as inline
 * @author biyu
 *
 * @param <V>
 */
public class CallableQueueTask<V> extends AbstractQueueTask implements Callable<V> {

	private Callable<V> callable;
	
	/** constructor */
	public CallableQueueTask(Callable<V> callable, QueueTaskGroup group, String name, QueueTaskPriority priority) {
		super(group, name, priority);
		this.callable = callable;
	}
	
	/** constructor, used default name */
	public CallableQueueTask(Callable<V> callable, QueueTaskGroup group, QueueTaskPriority priority) {
		super(group, priority);
		this.callable = callable;
	}
	
	/** constructor */
	public CallableQueueTask(Callable<V> callable, QueueTaskGroup group) {
		super(group);
		this.callable = callable;
	}

	/** constructor */
	public CallableQueueTask(Callable<V> callable) {
		super(QueueTaskGroups.UNKNOWN);
		this.callable = callable;
	}
	
	@Override
	public V call() throws Exception {
		return callable.call();
	}

}
