package org.lightj.concurrent;

/**
 * Runnable task to be submitted into the queue
 * 
 * @author biyu
 *
 */
public interface IQueueTask extends Comparable<IQueueTask> {
	
	/**
	 * name of the task
	 * @return
	 */
	public String getName();
	
	/**
	 * group of the task, groupname has to be registered first 
	 * by {@link PriorityRoundRobinThreadPoolExecutor#registTaskGroup(String, QueueTaskType)}
	 * @return
	 */
	public QueueTaskGroup getGroup();
	
	/**
	 * task priority
	 * @return {@link QueueTaskPriority}
	 */
	public QueueTaskPriority getPriority();
	
	/**
	 * task status
	 * @return {@link QueueTaskStatus}
	 */
	public QueueTaskStatus getStatus();
	
	/**
	 * task stats
	 * @return
	 */
	public QueueTaskStats getStats();

}
