package org.lightj.concurrent;

/**
 * base queue task groups collections
 * @author biyu
 *
 */
public class QueueTaskGroups {

	/** create a new instance */
	protected static QueueTaskGroup newInstance(String groupName, QueueTaskType type) {
		return QueueTaskGroup.newInstance(groupName, type);
	}
 
	// jms
	public static final QueueTaskGroup JMS	=	
		newInstance("JMS", QueueTaskType.preemptive);
	
	// caching
	public static final QueueTaskGroup CACHE = 
		newInstance("CACHE", QueueTaskType.preemptive);
	
	// task monitoring
	public static final QueueTaskGroup TASKMONITOR = 
		newInstance("TASKMONITOR", QueueTaskType.preemptive);
	
	public static final QueueTaskGroup TEST = 
		newInstance("TEST", QueueTaskType.canwait);

	// unknown group
	public static final QueueTaskGroup UNKNOWN = 
		newInstance("UNKNOWN", QueueTaskType.roundrobin);
}
