package org.lightj.concurrent;

/**
 * Queue task priority
 * 
 * @author biyu
 *
 */
public enum QueueTaskPriority {
	
	/**
	 * default priority
	 */
	high(1), medium(5), low(9), 
	one(1), two(2), three(3), four(4), five(5), 
	six(6), seven(7), eight(8), nine(9);
	
	/** priority as number */
	private int priority;
	/** constructor */
	QueueTaskPriority(int priority) {
		this.priority = priority;
	}
	/** get priority as number */
	public int getPriority() {
		return priority;
	}
	/** find a QueueTaskPriority by an int */
	public static QueueTaskPriority valueOfInt(int priority) {
		priority = Math.min(9, priority);
		priority = Math.max(1, priority);
		for (QueueTaskPriority p : values()) {
			if (p.getPriority() == priority) return p;
		}
		throw new IllegalArgumentException("Invalid argument : " + priority);
	}

}
