package org.lightj.concurrent;

/**
 * convenient queue task to be used as inline
 * @author biyu
 *
 */
public class RunnableQueueTask extends AbstractQueueTask implements Runnable {
	
	private Runnable runnable;

	/** constructor */
	public RunnableQueueTask(Runnable runnable, QueueTaskGroup group, String name, QueueTaskPriority priority) {
		super(group, name, priority);
		this.runnable = runnable;
	}
	
	/** constructor, used default name */
	public RunnableQueueTask(Runnable runnable, QueueTaskGroup group, QueueTaskPriority priority) {
		super(group, priority);
		this.runnable = runnable;
	}
	
	/** constructor */
	public RunnableQueueTask(Runnable runnable, QueueTaskGroup group) {
		super(group);
		this.runnable = runnable;
	}

	/** constructor */
	public RunnableQueueTask(Runnable runnable) {
		super(QueueTaskGroups.UNKNOWN);
		this.runnable = runnable;
	}

	@Override
	public void run() {
		runnable.run();
	}

}
