package org.lightj.concurrent;

import java.util.concurrent.ThreadPoolExecutor;

import org.lightj.util.nanoxml.XMLElement;


/**
 * thread pool executor stats
 * 
 * @author biyu
 *
 */
public final class ThreadPoolStats extends CounterStats {
	
	/** thread pool executor this stats links to */
	private final ThreadPoolExecutor executor;
	
	/** constructor */
	public ThreadPoolStats(String name, ThreadPoolExecutor executor) {
		super(name, "ThreadPoolStats");
		this.executor = executor;
	}

	@Override
	protected void asXml(XMLElement statElem) {
		super.asXml(statElem);
		statElem.setAttribute("corePoolSize", executor.getCorePoolSize());
		statElem.setAttribute("maxPoolSize", executor.getMaximumPoolSize());
		statElem.setAttribute("actualPoolSize", executor.getPoolSize());
		statElem.setAttribute("activeCount", executor.getActiveCount());
		statElem.setAttribute("completedTaskCount", executor.getCompletedTaskCount());
		statElem.setAttribute("scheduledTaskCount", executor.getTaskCount());
	}
	
	public final int getPoolSize() {
		return executor.getPoolSize();
	}
	public final int getActiveCount() {
		return executor.getActiveCount();
	}

}
