package org.lightj.config;

import java.lang.reflect.Field;

/**
 * configuration using {@link XmlConfig}
 * 
 * @author binyu
 *
 */
public class AnnontatedRuntimeConfigs extends BaseRuntimeConfigs {

	@Override
	public void load(IConfigManager cfgMgr) {
		setAllConfigValues(cfgMgr);
		notifyConfigEventListener(ConfigEventEnum.LOAD, null, null, null);
	}

	/**
	 * set all fields to values from xml config file based on {@link XmlConfig}
	 * 
	 * @param cfgMgr
	 */
	protected void setAllConfigValues(IConfigManager cfgMgr) {
		Field[] fields = this.getClass().getFields();
		for (Field field : fields) {
			XmlConfig cfgDef = field.getAnnotation(XmlConfig.class);
			
			if (cfgDef != null) {
				String product = cfgDef.cfgSet();
				String name = cfgDef.cfgName();
				Object nv = cfgMgr.getObject(product, name, null);
				if (nv != null) {
					try {
						updateValue(field, name, nv);
					} catch (ConfigUpdateException e) {
						logger.error(e);
					}
				}
			}
		}
	}
	
}
