package org.lightj.config;

import java.util.Map.Entry;

import org.apache.log4j.Category;
import org.apache.log4j.Logger;
import org.lightj.config.ConfigManager.Wrapper;
import org.lightj.util.nanoxml.XMLElement;


/**
 * expose configuration as xml content
 * 
 * @author biyu
 *
 */
public class ConfigComponentStatus {
	
	/** logger */
	static Category logger = Logger.getLogger(ConfigComponentStatus.class);

	/** singleton */
	private static ConfigComponentStatus s_instance = null;

	/** constructor */
	private ConfigComponentStatus(){
	}
	
	/** singleton */
	public static synchronized final ConfigComponentStatus getInstance() {
		if (s_instance == null) {
			s_instance = new ConfigComponentStatus();
		}
		return s_instance;
	}
	
	/** property to xml */
	public synchronized XMLElement getPropertiesAsXml() {
		XMLElement root = new XMLElement();
		root.setName(getName());
		root.setAttribute("categoryId", "lightj.config");
		for (Entry<String, Wrapper> entry : ConfigManager.products.entrySet()) {
			root.addChild(entry.getValue().mgr.asXml());
		}
		return root;
	}

	/** alias */
	public String getAlias() {
		return getName();
	}

	/** name */
	public String getName() {
		return "lightj.Config";
	}

	/** status */
	public String getStatus() {
		return "CREATED";
	}

}
