package org.lightj.config;

import java.util.EnumSet;
import java.util.Set;

/**
 * listener handle configuration change 
 * 
 * @author binyu
 *
 */
public interface ConfigEventListener {
	
	/**
	 * configuration change
	 * @param event
	 * @param fieldName
	 * @param oldValue
	 * @param newValue
	 */
	public void onConfigEvent(ConfigEventEnum event, String fieldName, Object oldValue, Object newValue);
	
	/**
	 * set of field name this listener is interested in
	 * @return
	 */
	public Set<String> listenToFields();
	
	/**
	 * set of config event this listener is interested in
	 * @return
	 */
	public EnumSet<ConfigEventEnum> listenToEvent();
	
}
