package org.lightj.config;

import org.lightj.util.Log4jProxy;
import org.lightj.util.StringUtil;

public enum EnvironmentEnum {

	NONE, PROD, SMOKE, LNP, QATE, QA, FEATURE, DEV
	;
	
	static Log4jProxy logger = Log4jProxy.getInstance(EnvironmentEnum.class);
	
	public static EnvironmentEnum valueOfStr(String value) {
		try {
			return StringUtil.isNullOrEmpty(value) ? NONE : valueOf(value.toUpperCase());
		} catch (Throwable t) {
			logger.error("invalid environment enum name " + value, t);
			return NONE;
		}
	}
	
}
