package org.lightj.config;


public class LightJRuntimeConfigs extends AnnontatedRuntimeConfigs {
	
	private static LightJRuntimeConfigs me = new LightJRuntimeConfigs();
	
	public static LightJRuntimeConfigs getInstance() {
		return me;
	}
	
	private LightJRuntimeConfigs() {}

	@XmlConfig(cfgSet="threadpool", cfgName="coreThreadSize")
	public static int coreThreadSize = 50;		
	
	@XmlConfig(cfgSet="threadpool", cfgName="maxThreadSize")
	public static int maxThreadSize = 75;
	
	@XmlConfig(cfgSet="threadpool", cfgName="maxIdelTimeSec")
	public static long maxIdleTimeSec = 60;
	
	@XmlConfig(cfgSet="flow", cfgName="flowRetryIntervalSec")
	public static int flowRetryIntervalSec = 600;
	
	@XmlConfig(cfgSet="flow", cfgName="flowJoinMonitorIntervalSec")
	public static int flowJoinMonitorIntervalSec = 10;
	
	@XmlConfig(cfgSet="flow", cfgName="logDrainerProcessIntervalSec")
	public static int logDrainerProcessIntervalSec = 5;
	
	@XmlConfig(cfgSet="jms", cfgName="jmsIntialContextFactory")
	public static String jmsIntialContextFactory = "org.apache.activemq.jndi.ActiveMQInitialContextFactory";
	
	@XmlConfig(cfgSet="jms", cfgName="jmsConnectionFactory")
	public static String jmsConnectionFactory = "TopicConnectionFactory";
	
	@XmlConfig(cfgSet="jms", cfgName="jmsQueueConnFactory")
	public static String jmsQueueConnFactory = "QueueConnectionFactory";
	
	@XmlConfig(cfgSet="jms", cfgName="jmsHistorySize")
	public static int jmsHistorySize = 10;

	@XmlConfig(cfgSet="jms", cfgName="messageTTL")
	public static long messageTTL = 30 * 60 * 1000L;
}
