package org.lightj.example.session;

import org.lightj.session.FlowContext;

/**
 * Session context
 * @author biyu
 *
 */
public class HelloWorldFlowContext extends FlowContext {

	static final String META_COUNT	=	"META_COUNT";
	static final String META_SPLIT_COUNT	=	"META_SPLIT_COUNT";
	static final String META_FORLOOP_COUNT	=	"META_FORLOOP_COUNT";
	static final String META_WHILELOOP_COUNT	=	"META_WHILELOOP_COUNT";
	static final String META_CHILD_FAILURE	=	"META_CHILD_FAILURE";
	static final String META_RUN_COUNT	=	"META_RUN_COUNT";
	static final String META_TIMEOUT_COUNT	=	"META_TIMEOUT_COUNT";
	
	public void setScheduledRunCount(int count) {
		setIntParam(META_COUNT, count);
	}
	public int getScheduledRunCount() {
		return getIntParam(META_COUNT, 0);
	}
	public synchronized void setSplitCount(int count) {
		setIntParam(META_SPLIT_COUNT, count);
	}
	public synchronized int getSplitCount() {
		return getIntParam(META_SPLIT_COUNT, 0);
	}
	public synchronized int incSplitCount() {
		int cnt = getSplitCount();
		setSplitCount(++cnt);
		return cnt;
	}
	public void setForLoopCount(int count) {
		setIntParam(META_FORLOOP_COUNT, count);
	}
	public int getForLoopCount() {
		return getIntParam(META_FORLOOP_COUNT, 0);
	}
	public void setWhileLoopCount(int count) {
		setIntParam(META_WHILELOOP_COUNT, count);
	}
	public int getWhileLoopCount() {
		return getIntParam(META_WHILELOOP_COUNT, 0);
	}
	public void setChildFailure(boolean hasFailure) {
		setBooleanParam(META_CHILD_FAILURE, hasFailure);
	}
	public boolean hasChildFailure() {
		return getBooleanParam(META_CHILD_FAILURE, false);
	}
	public int getRunCount() {
		return getIntParam(META_RUN_COUNT, 0);
	}
	public void setRunCount(int runCount) {
		setIntParam(META_RUN_COUNT, runCount);
	}
	public int getTimeoutCount() {
		return getIntParam(META_TIMEOUT_COUNT, 0);
	}
	public void setTimeoutCount(int timeoutCount) {
		setIntParam(META_TIMEOUT_COUNT, timeoutCount);
	}
}