package org.lightj.example.task;

import org.lightj.task.MonitorEvent;
import org.lightj.task.MonitorOption;
import org.lightj.task.TaskExecutionException;
import org.lightj.task.TaskMonitor;
import org.lightj.task.TaskResult;
import org.lightj.task.TaskResultEnum;

public class SimpleASyncTaskMonitor extends TaskMonitor<SimpleASyncTask> {
	
	public SimpleASyncTaskMonitor(MonitorOption monitorOption) {
		super(monitorOption);
	}

	@Override
	public void handleCancel(MonitorEvent<SimpleASyncTask> event, String reason)
			throws TaskExecutionException {
		// noop
	}

	@Override
	public void handleTimeout(MonitorEvent<SimpleASyncTask> event)
			throws TaskExecutionException {
		// noop
	}

	@Override
	public boolean monitorTask(MonitorEvent<SimpleASyncTask> event)
			throws TaskExecutionException {
		SimpleASyncTask task = event.getTask();
		if (task != null) {
			boolean completed = task.isComplete();
			if (completed) {
				event.getTaskListener().handleTaskResult(TaskResult.createLocal(task, TaskResultEnum.Success, ""));
			}
			return !task.isComplete();
		}
		return true;
	}

}
