package org.lightj.jms;

import org.lightj.util.nanoxml.XMLElement;


	
public class JmsComponentStatus {
	private static JmsComponentStatus s_instance = null;

	public static synchronized final JmsComponentStatus getInstance(){
		if (s_instance == null) {
			s_instance = new JmsComponentStatus();
		}
		return s_instance;
	}
	
	private JmsComponentStatus(){
	}
	
	public String getName() {
		return "eko.Jms";
	}
	
	public String getAlias() {
		return getName();
	}

	public String getStatus() {
		return "CREATED";
	}

	/** property to xml */
	public synchronized XMLElement getPropertiesAsXml() {
		XMLElement root = new XMLElement();
		root.setName(getName());
		root.setAttribute("categoryId", "eko.Jms");
		for (JmsSessionWrapper sess : MessageManager.getInstance().getExistingSess()) {
			root.addChild(sess.getStats().asXml());
		}
		if(root.getChildren().isEmpty()){
			root.setContent("No Jms Connection is Available");
		}
		return root;
	}

}
