package org.lightj.jms;

import java.util.concurrent.ExecutorService;

import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Session;

/**
 * wrap original jms session setup request
 * @author biyu
 *
 */
public class JmsSessionWrapper {
	
	/** original session property from requester */
	JmsConfig sessProp;
	/** stats */
	ConnectionStats stats;
	/** jms consumer */
	ConsumerWrapper jmsConsumer;
	/** jms producer */
	ExecutorService producerExecutor;

	JmsSessionWrapper(JmsConfig sess) {
		this.sessProp = sess;
		this.stats = new ConnectionStats(sess.getProviderUrl(), sess.getName(), sess.isProducing(), sess.isConsuming()); 
	}
	
	ConnectionStats getStats() {
		return stats;
	}
	
	void addConsumer(Session jmsSess, MessageConsumer consumer, ExecutorService executor, boolean internalExecutor) {
		jmsConsumer = new ConsumerWrapper(jmsSess, consumer, executor, internalExecutor);
	}
	
	static class ConsumerWrapper {
		public ConsumerWrapper(Session jmsSess, MessageConsumer consumer, ExecutorService executor, boolean internalExecutor) {
			this.jmsSess = jmsSess;
			this.consumer = consumer;
			this.exeuctor = executor;
			this.internalExecutor = internalExecutor;
		}
		Session jmsSess;
		MessageConsumer consumer;
		ExecutorService exeuctor;
		boolean internalExecutor;
		void shutdown() throws JMSException {
			consumer.close();
			jmsSess.close();
			if (internalExecutor) exeuctor.shutdownNow();
		}
	}

	ExecutorService getProducerExecutor() {
		return producerExecutor;
	}

	void setProducerExecutor(ExecutorService producerExecutor) {
		this.producerExecutor = producerExecutor;
	}
	
}
