/*
 * Created on Jan 4, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.lightj.schedule;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

/**
 * @author biyu
 * interface used by {@link org.lightj.schedule.Schedulable} to store data
 * related to the job.
 */
@SuppressWarnings("rawtypes")
public interface IExecutionContext extends Serializable {
	
	public static final String METHOD_TO_EXECUTE	= 	"METHOD_TO_EXECUTE";
	public static final String SCHEDULABLE_ID		=	"SCHEDULABLE_ID";
	
	public int getIntParm(String name, int defVal);
	public void setIntParm(String name, int val);
	public long getLongParm(String name, long defVal);
	public void setLongParm(String name, long val);
	public double getDoubleParm(String name, double defVal);
	public void setDoubleParm(String name, double val);
	public boolean getBooleanParm(String name, boolean defVal);
	public void setBooleanParm(String name, boolean val);
	public Date getDateParm(String name, boolean includeTime, Date defVal);
	public void setDateParm(String name, Date val);
	public String getStringParm(String name, String defVal);
	public void setStringParm(String name, String val);
	
	/**
	 * Get any parameter that is {@link Serializable}
	 * @param name
	 * @return
	 */
	public Serializable getParm(String name);
	
	/**
	 * Set any parameter taht is {@link Serializable}
	 * @param name
	 * @param val
	 */
	public void setParm(String name, Serializable val);
	
	/**
	 * Remove a parameter
	 * @param name
	 */ 
	public void removeParm(String name);
	
	/**
	 * Clear all parameters.
	 */
	public void clear();
	
	/**
	 * Get all parameters as a map.
	 * @return
	 */
	public Map getAll();
	
	/**
	 * Add all parameters from a map.
	 * @param all
	 */
	public void putAll(Map all);

}
