package org.lightj.schedule;

import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.JobListener;

public class JobCleanupListener implements JobListener {

	private String name = "JobCleanup"; 

	public String getName() {
		return this.name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public void jobToBeExecuted(JobExecutionContext context) {
		// do nothing
	}

	public void jobExecutionVetoed(JobExecutionContext context) {
		// do nothing
	}

	public void jobWasExecuted(JobExecutionContext context,	JobExecutionException jobException) {
		try {
			boolean cleanupAfterFire = context.getMergedJobDataMap().getBoolean(QuartzScheduler.CLEANUPAFTERFIRE);
			
			if (cleanupAfterFire && context.getNextFireTime() == null) {
				// we don't persist in persistent_obj_ref now, do nothing
			}
		}
		catch (Throwable t) {
			// failed to cleanup, it's ok
		}
	}
	
}
