/*
 * Created on Jan 4, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.lightj.schedule;

import java.util.List;

import org.lightj.dal.Locatable;


/**
 * @author biyu
 * Class implement this interface can be scheduled by {@link SchedulerFactory} 
 */
public interface Schedulable extends Locatable {
	
	/**
	 * Execute a job.
	 * @param ctx	persistent data for this job
	 */
	public void execute(IExecutionContext ctx);
	
	/**
	 * Interrup an executing job. {@see SchedulerFactory#interrup(Schedulable)}
	 */
	public void interrupt();
	
	/**
	 * Get list of {@link ISchedule}
	 * @return
	 */
	public List<ISchedule> getSchedules();
	
	/**
	 * Add a new {@link ISchedule}
	 * @param schedule
	 */
	public void addSchedule(ISchedule schedule);
	
	/**
	 * Remove a {@link ISchedule}
	 * @param schedule
	 */
	public void removeSchedule(ISchedule schedule);

}
