package org.lightj.schedule;

import org.apache.log4j.Category;
import org.apache.log4j.Logger;
import org.lightj.util.nanoxml.XMLElement;


/**
 * component status for thread pools
 * 
 * @author biyu
 *
 */
public class SchedulerComponentStatus {
	
	static Category logger = Logger.getLogger(SchedulerComponentStatus.class);

	/** singleton */
	private static SchedulerComponentStatus s_instance = null;

	/** constructor */
	private SchedulerComponentStatus(){
	}
	
	/** singleton */
	public static final SchedulerComponentStatus getInstance() {
		if (s_instance == null) {
			s_instance = new SchedulerComponentStatus();
		}
		return s_instance;
	}
	
	/** property to xml */
	public synchronized XMLElement getPropertiesAsXml() {
		XMLElement root = new XMLElement();
		root.setName(getName());
		root.setAttribute("categoryId", "eko.Scheduler");
		for (String key : SchedulerFactory.getExistingSchedulerNames()) {
			SchedulerFactory scheduler = SchedulerFactory.getInstance(key);
			XMLElement elem = scheduler.getStatsXml();
			elem.setAttribute("schedulerName", key);
			root.addChild(elem);
		}
		if(root.getChildren().isEmpty()){
			root.setContent("No Scheduler is Enabled");
		}
		return root;
	}

	/** alias */
	public String getAlias() {
		return getName();
	}

	/** name */
	public String getName() {
		return "eko.Scheduler";
	}

	/** status */
	public String getStatus() {
		return "CREATED";
	}

}
