/**
 * Created on Jan 4, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.lightj.schedule;

import java.util.HashMap;
import java.util.List;

import org.lightj.util.nanoxml.XMLElement;
import org.quartz.SchedulerException;


import org.apache.log4j.Category;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;

/**
 * @author biyu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
@SuppressWarnings("rawtypes")
abstract public class SchedulerFactory {
	
	public static final String SCHEDULER_PERSISTENT		=		SchedulerTypeEnum.SCHEDULER_PERSISTENT.name();
	public static final String SCHEDULER_TRANSIENT		=		SchedulerTypeEnum.SCHEDULER_TRANSIENT.name();
	
	private static final HashMap<String, SchedulerFactory> SCHEDULERMAP		=		new HashMap<String, SchedulerFactory>();
	static Category logger = Logger.getLogger(SchedulerFactory.class);
	
	public static SchedulerFactory getInstance(String key) {
		if (!SCHEDULERMAP.containsKey(key)) {
			throw new IllegalArgumentException("Scheduler " + key + " doesn't exist");
		}
		return (SchedulerFactory) SCHEDULERMAP.get(key);
	}
	
	public static SchedulerFactory getInstance(SchedulerTypeEnum type) {
		return getInstance(type.name());
	}
	
	public static void addInstance(String key, Object scheduler) {
		addInstance(key, scheduler, false);
	}

	public static synchronized void addInstance(String key, Object scheduler, boolean isTransient) {
		QuartzScheduler s = new QuartzScheduler();
		s.setThirdPartyScheduler(scheduler);
		s.setTransient(isTransient);
		if (!isTransient && scheduler instanceof org.quartz.Scheduler) {
			try {
				((org.quartz.Scheduler) scheduler).addJobListener(new JobCleanupListener());
			} catch (SchedulerException e) {
				logger.log(Level.ERROR, e);
			}
		}
		SCHEDULERMAP.put(key, s);
	}
	
	abstract public void schedule(Schedulable schedulable) throws ScheduleException;
	
	abstract public void cancel(Schedulable s) throws ScheduleException;

	abstract public void pause(Schedulable s) throws ScheduleException;
	
	abstract public void resume(Schedulable s) throws ScheduleException;
	
	abstract public void interrupt(Schedulable s) throws ScheduleException;
	
	abstract public void reschedule(Schedulable s) throws ScheduleException;

	abstract public ISchedule createSchedule(String description) throws ScheduleException;
	
	abstract public void pause() throws ScheduleException;
	
	abstract public void resume() throws ScheduleException;
	
	abstract public void pause(Class schedulableKlass) throws ScheduleException;
	
	abstract public void resume(Class scheulableKlass) throws ScheduleException;
	
	abstract public void start() throws ScheduleException;
	
	abstract public void shutdown() throws ScheduleException;
	
	abstract public List<ISchedule> getSchedules(Schedulable scheulableKlass) throws ScheduleException;
	
	abstract public XMLElement getStatsXml();

	/**
	 * @return existing schedulers initialized with KernelInitilizer
	 */
	public static final java.util.Set<String> getExistingSchedulerNames() {
		return SCHEDULERMAP.keySet();
	}

}
