package org.lightj.session;

import org.lightj.clustering.ClusteringEventHandler;
import org.lightj.clustering.ClusteringManager;
import org.lightj.util.Log4jProxy;
import org.lightj.util.StringUtil;

import com.sun.enterprise.ee.cms.core.FailureNotificationSignal;
import com.sun.enterprise.ee.cms.core.FailureSuspectedSignal;
import com.sun.enterprise.ee.cms.core.GroupLeadershipNotificationSignal;
import com.sun.enterprise.ee.cms.core.JoinNotificationSignal;
import com.sun.enterprise.ee.cms.core.JoinedAndReadyNotificationSignal;
import com.sun.enterprise.ee.cms.core.PlannedShutdownSignal;

public class FlowClusteringEventHandler implements ClusteringEventHandler {
	
	static Log4jProxy logger = Log4jProxy.getInstance(FlowClusteringEventHandler.class);

	public void handleFailureNotificationSignal(FailureNotificationSignal signal) {
		recoverFromDownNode(signal.getMemberToken());
	}

	public void handleFailureSuspectedSignal(FailureSuspectedSignal signal) {
	}

	public void handleGroupLeadershipSignal(GroupLeadershipNotificationSignal signal) {
	}

	public void handleJoinNotificationSignal(JoinNotificationSignal signal) {
	}

	public void handleJoinedAndReadySignal(JoinedAndReadyNotificationSignal signal) {
	}

	public void handlePlannedShutdownSignal(PlannedShutdownSignal signal) {
		recoverFromDownNode(signal.getMemberToken());
	}

	/**
	 * recover session from creashed/down server
	 * @param nodeId
	 */
	private void recoverFromDownNode(String nodeId) {
		if (!StringUtil.isNullOrEmpty(nodeId)) {
			String runBy = nodeId.split("-")[0];
			runBy = StringUtil.decode(ClusteringManager.hostNameEncoding, runBy);
			if (!StringUtil.isNullOrEmpty(runBy)) {
				logger.info("Try to recover sessions from remote crash/down server " + runBy);
				FlowSessionFactory.getInstance().recoverCrashedSession(runBy);
			}
		}
	}
}

