package org.lightj.session;

public class FlowStepOptions {

	/**
	 * relative weight of the step, used to calculate flow progress
	 */
	private int stepWeight = 1;
	
	/**
	 * setting this property to true will force flow driver
	 * to persist logs of a flow step execution to session step log
	 * at end of a flow step execution
	 */
	private boolean persistStepHistory = true;
	
	/**
	 * delay execution
	 */
	private long delayMs = 0;
	
	/**
	 * time out after
	 */
	private long timeoutMs = 0;
	
	public long getTimeoutMs() {
		return timeoutMs;
	}

	public void setTimeoutMs(long timeoutMs) {
		this.timeoutMs = timeoutMs;
	}

	public int getStepWeight() {
		return stepWeight;
	}

	public void setStepWeight(int stepWeight) {
		this.stepWeight = stepWeight;
	}

	public boolean isPersistStepHistory() {
		return persistStepHistory;
	}

	public void setPersistStepHistory(boolean persistStepHistory) {
		this.persistStepHistory = persistStepHistory;
	}

	public long getDelayMs() {
		return delayMs;
	}

	public void setDelayMs(long delayMs) {
		this.delayMs = delayMs;
	}

	public void setPredefinedProperties(int stepWeight, boolean persistStepHistory) {
		this.stepWeight = stepWeight;
		this.persistStepHistory = persistStepHistory;
	}
	
}
