package org.lightj.session;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface FlowStepProperties {
	
	/**
	 * relative weight of the step, used to calculate flow progress
	 * @return
	 */
	int stepWeight() 	default 1;
	
	/**
	 * setting this property to true will force flow driver
	 * to persist logs of a flow step execution to session step log
	 * at end of a flow step execution
	 * @return
	 */
	boolean persistStepHistory()	default true;
	
}

