package org.lightj.session;

import org.lightj.concurrent.QueueTaskGroup;

@SuppressWarnings("rawtypes")
public class FlowTypeImpl implements FlowType {

	/** flow type int, unique */
	private final int value;

	/** flow description */
	private final String desc;

	/** flow class */
	private final Class<? extends FlowSession> klass;

	/** flow context class */
	private final Class<? extends FlowContext> ctxKlass;

	/** optional grouping for better concurrency */
	private final QueueTaskGroup taskGroup;

	
	public int value() {
		return value;
	}

	public String desc() {
		return desc;
	}

	public Class<? extends FlowSession> getFlowKlass() {
		return klass;
	}

	public Class<? extends FlowContext> getCtxKlass() {
		return ctxKlass;
	}

	public QueueTaskGroup getTaskGroup() {
		return taskGroup;
	}

	protected FlowTypeImpl(int value, String desc, Class<? extends FlowSession> klass,
			Class<? extends FlowContext> ctxKlass, QueueTaskGroup taskGroup) {

		this.value = value;
		this.desc = desc;
		this.klass = klass;
		this.ctxKlass = ctxKlass;
		this.taskGroup = taskGroup;
	}
	
	public String getLabel() {
		return desc;
	}

	public String getValue() {
		return Integer.toString(value);
	}

}
