package org.lightj.session.dal;

import org.lightj.dal.AbstractDAO;
import org.lightj.dal.BaseSequenceEnum;
import org.lightj.dal.DataAccessRuntimeException;

/**
 * session data manager implementation
 * @author biyu
 *
 */
public class SessionDataManagerImpl extends AbstractDAO<SessionDataImpl> implements ISessionDataManager<SessionDataImpl> {

	private static final SessionDataManagerImpl me = new SessionDataManagerImpl();

	public static final SessionDataManagerImpl getInstance() {
		return me;
	}

	private SessionDataManagerImpl() {
		super();
		register(SessionDataImpl.class, SessionDataImpl.TABLENAME, null, BaseSequenceEnum.SEQ_FLOW_ID,
		new String[] {"flow_id", "creation_date","end_date", "flow_status","target","flow_type", "parent_id",
			"current_action", "next_action", "flow_state", "flow_result", "last_modified", "run_by","requester"},
		new String[] {"flowId", "creationDate", "endDate", "status", "targetKey", "type", "parentId",
			"currentAction", "nextAction", "actionStatus", "resultStatus", "lastModified", "runBy","requesterKey"} 
		);
	}

	/**
	 * create new instance of session data
	 */
	public SessionDataImpl newInstance() throws DataAccessRuntimeException {
		try {
			return doKlass.newInstance();
		} catch (IllegalAccessException e) {
			throw new DataAccessRuntimeException(e);
		} catch (InstantiationException e) {
			throw new DataAccessRuntimeException(e);
		}
	}

}
