package org.lightj.session.step;

import org.lightj.session.FlowContext;
import org.lightj.task.Task;
import org.lightj.task.TaskMonitor;
import org.lightj.task.TaskRunner;

@SuppressWarnings("rawtypes")
public class AsyncStepBuilder<T extends FlowContext> extends StepBuilder {
	
	public AsyncStepBuilder executeAsyncTask(
			TaskRunner taskRunner,
			StepErrorHandler execErrorHandler, 
			StepCallbackHandler resultHandler, 
			StepErrorHandler resultErrorHandler,
			Task...tasks) 
	{
		AsyncTaskStepExecution<T> execution = new AsyncTaskStepExecution<T>(taskRunner, resultHandler);
		execution.addTasks(tasks);
		super.execute(execution, execErrorHandler);
		super.onCallback(resultHandler, resultErrorHandler);
		return this;
	}
	
	public AsyncStepBuilder executeAsyncPollTask(
			TaskRunner taskRunner,
			TaskMonitor taskMonitor,
			StepErrorHandler execErrorHandler, 
			StepCallbackHandler resultHandler, 
			StepErrorHandler resultErrorHandler,
			Task...tasks) 
	{
		AsyncTaskStepExecution<T> execution = new AsyncTaskStepExecution<T>(taskRunner, resultHandler, taskMonitor);
		execution.addTasks(tasks);
		super.execute(execution, execErrorHandler);
		super.onCallback(resultHandler, resultErrorHandler);
		return this;
	}
	
}
