package org.lightj.session.step;

import org.lightj.session.FlowContext;
import org.lightj.session.FlowExecutionException;
import org.lightj.session.step.FlowStepBuilder.FlowTask;
import org.lightj.task.ExecuteOption;
import org.lightj.task.ITaskListener;
import org.lightj.task.Task;
import org.lightj.task.TaskRunner;

/**
 * a flow step to run sub flows
 * 
 * @author biyu
 * 
 */
@SuppressWarnings({ "rawtypes" })
public class FlowStepExecution<T extends FlowContext> extends AsyncTaskStepExecution<T> {
	
	/**
	 * constructor
	 */
	public FlowStepExecution(TaskRunner runner, ITaskListener taskListener) {
		super(runner, taskListener);
	}

	/**
	 * constructor
	 */
	public FlowStepExecution(TaskRunner runner, ITaskListener taskListener, ExecuteOption execOptions) {
		super(runner, taskListener);
		this.execOptions = execOptions;
	}

	/**
	 * submit the task to be run by task runner
	 */
	@Override
	public StepTransition execute() throws FlowExecutionException {
		long parentFlowId = this.sessionContext.getSessionId();
		for (Task task : tasks) {
			((FlowTask) task).setParentFlowId(parentFlowId);
		}
		return super.execute();
	}

}
