package org.lightj.session.step;

@SuppressWarnings("rawtypes")
public class StepBuilder {

	/**
	 * flow step concrete impl
	 */
	protected StepImpl flowStep = new StepImpl();

	/**
	 * get flow step impl
	 * @return
	 */
	public StepImpl getFlowStep() {
		return flowStep;
	}

	public StepBuilder execute(StepExecution execution, StepErrorHandler errorHandler) {
		flowStep.setExecution(execution);
		flowStep.setExecutionErrorHandler(errorHandler);
		return this;
	}
	
	public StepBuilder onCallback(StepCallbackHandler callbackHandler, StepErrorHandler errorHandler) {
		flowStep.setResultHandler(callbackHandler);
		flowStep.setResultErrorHandler(errorHandler);
		return this;
	}
	
}
