package org.lightj.session.step;

import java.io.Serializable;

/**
 * step progress, used to track step execution and recover if possible
 * @author binyu
 *
 */
public class StepProgressInfo implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -328166336439479613L;
	
	/**
	 * step state
	 * @author binyu
	 *
	 */
	public static enum ProgressState {
		Started,
		Callback,
		Result,
		Complete,
	}
	
	public String stepName;
	public String executionId;
	public ProgressState state; 
	public String info;
	
	public static final StepProgressInfo newInstance(String stepName, String executionId, ProgressState state, String info) {
		if (stepName == null) {
			throw new IllegalArgumentException("Step name cannot be empty");
		}
		StepProgressInfo sp = new StepProgressInfo();
		sp.stepName = stepName;
		sp.executionId = executionId;
		sp.state = state;
		sp.info = info;
		return sp;
	}
	
	public void updateProgress(ProgressState state, String info) {
		this.state = state;
		this.info = info;
	}

}
