package org.lightj.task;

import java.io.Serializable;

public class ExecuteOption implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4329492405571153006L;

	/** timeout delta from now, 0 - infinite */
	protected long timeoutInMs;
	
	/** initial delay in millisecond, 0 - right away */
	protected long initialDelayMs;
	
	/** when it is started, in millisecond, used for tracking only */
	protected long startedAt;
	
	/** when to time out */
	protected long timeOutAt;
	
	protected ExecuteOption(long initialDelayMs, long timeoutInMs) 
	{
		this.initialDelayMs = initialDelayMs;
		this.timeoutInMs = timeoutInMs;
		long now = System.currentTimeMillis();
		this.startedAt = now + initialDelayMs;
		this.timeOutAt = timeoutInMs > 0 ? now + timeoutInMs : Long.MAX_VALUE;
	}

	public long getStartedAt() {
		return startedAt;
	}
	public long getTimeoutInMs() {
		return timeoutInMs;
	}
	public long getTimeOutAt() {
		return timeOutAt;
	}
	public long getInitialDelayMs() {
		return initialDelayMs;
	}
	public void setTimeoutInMs(long timeoutInMs) {
		this.timeoutInMs = timeoutInMs;
	}
	public void setInitialDelayMs(long initialDelayMs) {
		this.initialDelayMs = initialDelayMs;
	}
	public void setStartedAt(long startedAt) {
		this.startedAt = startedAt;
	}
	public void setTimeOutAt(long timeOutAt) {
		this.timeOutAt = timeOutAt;
	}
}
