package org.lightj.task;



/**
 * how the task monitoring is done
 * @author biyu
 *
 */
public final class MonitorOption extends ExecuteOption {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -5548160061694548326L;

	/** how often to run, in millisecond */
	private long monitorIntervalMs;
	
	/** when to run, in millisecond */
	private long nextRunAt;

	private MonitorOption(long initialDelayMs, long monitorIntervalMs, long timeoutInMs) {
		super(initialDelayMs, timeoutInMs);
		this.monitorIntervalMs = monitorIntervalMs;
		this.nextRunAt = this.startedAt;
	}

	public long getMonitorIntervalMs() {
		return monitorIntervalMs;
	}
	public long getNextRunAt() {
		return nextRunAt;
	}
	public void scheduleNextRun() {
		this.nextRunAt = System.currentTimeMillis() + monitorIntervalMs;
	}
	public void setMonitorIntervalMs(long monitorIntervalMs) {
		this.monitorIntervalMs = monitorIntervalMs;
	}
	public void setNextRunAt(long nextRunAt) {
		this.nextRunAt = nextRunAt;
	}

	/**
	 * create a new instance
	 * @param initialDelayMs
	 * @param monitorIntervalMs
	 * @param timeoutInMs
	 * @return
	 */
	public static MonitorOption newInstance(long initialDelayMs, long monitorIntervalMs, long timeoutInMs) {
		MonitorOption option = new MonitorOption(initialDelayMs, monitorIntervalMs, timeoutInMs);
		return option;
	}
	
}
