package org.lightj.util;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;

public class FileUtils {

	public static String readFile(String fileName, String characterEncoding)
			throws UnsupportedEncodingException, FileNotFoundException,
			IOException {
		FileInputStream fis;
		InputStreamReader isr;
		StringBuffer sb = new StringBuffer(75000);
		char[] buf = new char[4096];
		int numRead;
		fis = new FileInputStream(fileName);
		isr = new InputStreamReader(fis, characterEncoding);
		do {
			numRead = isr.read(buf, 0, buf.length);
			if (numRead > 0) {
				sb.append(buf, 0, numRead);
			}
		} while (numRead >= 0);
		isr.close();
		fis.close();
		return sb.toString();
	}

	/**
	 * This is a convenience method to read text from an input stream into a
	 * string. It will use the default encoding of the OS. It call the
	 * underlying readString(InputStreamReader)
	 * 
	 * @param inputStream
	 *            - InputStream
	 * @return String - the text that was read in
	 * @throws IOException
	 */
	public static String readStream(final InputStream inputStream)
			throws IOException {
		final InputStreamReader isr = new InputStreamReader(inputStream);
		try {
			return readStream(isr);
		} finally {
			isr.close();
		}
	}

	/**
	 * This is a convenience method to read text from a stream into a string.
	 * The transfer buffer is 4k and the initial string buffer is 75k. If this
	 * causes a problem, write your own routine.
	 * 
	 * @param isr
	 *            - InputStreamReader
	 * @return String - the text that was read in
	 * @throws IOException
	 */
	public static String readStream(final InputStreamReader isr)
			throws IOException {
		StringBuffer sb = new StringBuffer(75000);
		char[] buf = new char[4096];
		int numRead;
		do {
			numRead = isr.read(buf, 0, buf.length);
			if (numRead > 0) {
				sb.append(buf, 0, numRead);
			}
		} while (numRead >= 0);
		final String result = sb.toString();
		return result;
	}
}
