package org.lightj.util;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.json.JettisonMappedXmlDriver;
import com.thoughtworks.xstream.io.json.JsonHierarchicalStreamDriver;

@SuppressWarnings("rawtypes")
public class JSONUtil {

	/**
	 * This method converts an object into a JSON string. This is very very
	 * dangerous to call, this should be tested and used in rare situations.
	 * Dates are having major issues.
	 * 
	 * @param obj
	 * @throws Exception
	 */

	static XStream xs = new XStream(new JsonHierarchicalStreamDriver());

	public static String objectToJSON(Object obj) throws Exception {
		String string = xs.toXML(obj);
		return string;
	}

	/**
	 * This method converts an object into a JSON string.
	 */
	public static String ObjToJSON(Object obj, String aliasType)
			throws Exception {
		XStream xstream = new XStream(new JettisonMappedXmlDriver());
		xstream.setMode(XStream.NO_REFERENCES);
		xstream.alias(aliasType, obj.getClass());
		String jettisonValue = xstream.toXML(obj);
		return jettisonValue;
	}

	/**
	 * This method converts JSONized message to Object based on the Classname
	 * 
	 * @param msg
	 * @param aliasType
	 * @param className
	 * @return
	 * @throws Exception
	 */
	public static Object JSONToObj(String msg, String aliasType, Class className)
			throws Exception {
		XStream xstream = new XStream(new JettisonMappedXmlDriver());
		xstream.setMode(XStream.NO_REFERENCES);
		xstream.alias(aliasType, className);
		Object obj = xstream.fromXML(msg);
		return obj;

	}

}
