package org.lightj.util;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.codehaus.janino.ScriptEvaluator;

public class JaninoExecutor {

	/**
	 * Method to execute expression/script
	 * @param exprEvaluator
	 * @param parameterValues
	 * @return result
	 * @throws InvocationTargetException
	 */
	public static Object execute(ScriptEvaluator exprEvaluator, Object[] parameterValues)
	      throws InvocationTargetException {
		// Evaluate expression/script with actual parameter values.
		Object res = exprEvaluator.evaluate(parameterValues);
		return res;
	}

	/**
	 * Method to execute class body
	 * @param classDef
	 * @param methodName
	 * @param parametretypes
	 * @param parameterValues
	 * @param targetObject
	 * @return result as output
	 * @throws SecurityException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 */
	@SuppressWarnings({"rawtypes","unchecked"})
	public static Object executeClassBody(Class classDef, String methodName, Class[] parametretypes,
	      Object[] parameterValues, Object targetObject) throws SecurityException, NoSuchMethodException, IllegalArgumentException,
	      IllegalAccessException, InvocationTargetException {
		// Invoke the method.
		Method m = classDef.getMethod(methodName, parametretypes);
		//execute the method
		Object returnValue = (Integer) m.invoke(targetObject, parameterValues);
		return returnValue;
	}
}
